unalias
===

删除由alias设置的别名

###  主要用途

- 删除一个或多个别名。
- 删除全部已定义的别名。

###  语法

```shell
unalias [-a] name [name ...]
```

###  选项

```shell
-a：取消所有命令别名。
```

###  参数

name：指定要删除的一个或多个已定义的别名。

###  返回值

unalias返回true除非您要删除的别名未定义。

###  实例

```shell
#删除全部已定义的别名
unalias -a

#删除已定义的别名（假设当前环境存在以下别名：vi ls grep）
unalias vi
unalias ls grep
```

上面的命令执行后，系统会将指定的命令别名取消掉。

### 错误用法

- 要删除的别名未定义

- 不使用-a选项时没有传递name参数


### Q&A

Q：如何查看、设置别名？

A：请查看 `alias` 命令。


### 注意

1. ***请不要用这个命令对包括你自己在内的任何人开恶意的玩笑，原因如下：***

> 如果终端环境中存在别名，那么在其中使用 `source` 命令调用bash脚本会出现以下行为：当执行的命令存在别名时，会按照别名的值调用执行；
>
> 通过 `sh` 方式调用的bash脚本或直接运行当前用户有执行权限的脚本不受终端环境的别名影响。

2. 该命令是bash内建命令，相关的帮助信息请查看 `help` 命令。

<!-- Linux命令行搜索引擎：https://jaywcjlove.github.io/linux-command/ -->
